﻿using System;
using System.Linq;
using System.Web.Mvc;
using System.Collections;
using ScheduleCRUD.Models;

namespace ScheduleCRUD.Controllers
{
    public class HomeController : Controller
    {
        DataClasses1DataContext db = new DataClasses1DataContext();
        public ActionResult Index()
        {
            return View();
        }

        public JsonResult GetData()
        {
            IEnumerable data = new DataClasses1DataContext().ScheduleDatas.Take(100);
            return Json(data, JsonRequestBehavior.AllowGet);
        }

        public JsonResult Batch(EditParams param)
        {
            if (param.action == "insert" || (param.action == "batch" && param.added != null)) // this block of code will execute while inserting the appointments
            {
                ScheduleData appoint = new ScheduleData();
                object result;
                if (param.action == "insert")
                {
                    var value = param.value;
                    foreach (var fieldName in value.GetType().GetProperties())
                    {
                        var newName = fieldName.ToString().Split(null);
                        if (newName[1] == "Id") result = (db.ScheduleDatas.ToList().Count > 0 ? db.ScheduleDatas.ToList().Max(p => p.Id) : 1) + 1;
                        else if (newName[1] == "StartTime" || newName[1] == "EndTime") result = Convert.ToDateTime(fieldName.GetValue(value));
                        else result = fieldName.GetValue(value);
                        fieldName.SetValue(appoint, result);
                    }
                    db.ScheduleDatas.InsertOnSubmit(appoint);
                }
                else
                {
                    foreach (var item in param.added.Select((x, i) => new { Value = x, Index = i }))
                    {
                        var value = item.Value;
                        foreach (var fieldName in value.GetType().GetProperties())
                        {
                            var newName = fieldName.ToString().Split(null);
                            if (newName[1] == "Id") result = (db.ScheduleDatas.ToList().Count > 0 ? db.ScheduleDatas.ToList().Max(p => p.Id) : 1) + 1 + item.Index;
                            else if (newName[1] == "StartTime" || newName[1] == "EndTime") result = Convert.ToDateTime(fieldName.GetValue(value));
                            else result = fieldName.GetValue(value);
                            fieldName.SetValue(appoint, result);
                        }
                        db.ScheduleDatas.InsertOnSubmit(appoint);
                    }
                }
                db.SubmitChanges();
            }
            if ((param.action == "remove") || (param.action == "batch" && param.deleted != null)) // this block of code will execute while removing the appointment
            {
                if (param.action == "remove")
                {
                    ScheduleData app = db.ScheduleDatas.Where(c => c.Id == Convert.ToInt32(param.key)).FirstOrDefault();
                    if (app != null) db.ScheduleDatas.DeleteOnSubmit(app);
                }
                else
                {
                    foreach (var a in param.deleted)
                    {
                        var app = db.ScheduleDatas.ToList().Where(c => c.Id == Convert.ToInt32(a.Id)).FirstOrDefault();
                        if (app != null) db.ScheduleDatas.DeleteOnSubmit(app);
                    }
                }
                db.SubmitChanges();
            }
            if (param.action == "update" || (param.action == "batch" && param.changed != null)) // this block of code will execute while updating the appointment
            {
                var value = param.action == "update" ? param.value : param.changed[0];
                var filterData = db.ScheduleDatas.Where(c => c.Id == Convert.ToInt32(value.Id));
                if (filterData.Count() > 0)
                {
                    ScheduleData appoint = db.ScheduleDatas.Single(A => A.Id == Convert.ToInt32(value.Id));
                    appoint.StartTime = Convert.ToDateTime(value.StartTime);
                    appoint.EndTime = Convert.ToDateTime(value.EndTime);
                    appoint.StartTimeZone = value.StartTimeZone;
                    appoint.EndTimeZone = value.EndTimeZone;
                    appoint.Subject = value.Subject;
                    appoint.Recurrence = value.Recurrence;
                    appoint.AllDay = value.AllDay;
                    appoint.RecurrenceRule = value.RecurrenceRule;
                }
                db.SubmitChanges();
            }
            IEnumerable data = new DataClasses1DataContext().ScheduleDatas.Take(500);
            return Json(data, JsonRequestBehavior.AllowGet);
        }
    }
}